///home/berryj/link/bin/genMethods "-g" "-t" "MHyperGraph*" "-r" "Graph*" "-I" "LINK/graph/HyperGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "____mHyperGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/HyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef MHyperGraph* _MHyperGraph_;

#define _MHyperGraph_DATA(x) ((MHyperGraph**) (EXTDATA(x)))
#define _MHyperGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MHyperGraph* >::type))
#define _MHyperGraph_ISNT_DATA(x) (!_MHyperGraph_IS_DATA(x))

#define _MHyperGraph_CXX_DATA(x) (*(MHyperGraph**) (EXTDATA(VAL(x))))
#define _MHyperGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MHyperGraph* >::type))
#define _MHyperGraph_CXX_ISNT_DATA(x) (!_MHyperGraph_CXX_IS_DATA(x))


static SCM is_MHyperGraph_(SCM i)
{
	if (_MHyperGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init_____mHyperGraph_()
{
	Wrapper<_MHyperGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MHyperGraph_>::name, 
			Wrapper<Graph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_MHyperGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("MHyperGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_MHyperGraph_);
	return UNDEFINED;
}

void genExtra____mHyperGraph_Methods(void);

PRIMITIVE STk_init_methods_____mHyperGraph_()
{
	genExtra____mHyperGraph_Methods();
	return UNDEFINED;
}
